//================================================================================================
// $Id: cgvisitor.h 6308 2023-01-16 20:16:41Z aron $
//
// Project:
//		Welltype Compiler
// Contents:
//		Code generator visitor
// Authors:
//		Aron Barath, 2014-2023
//================================================================================================
// Copyright (c) Aron Barath
//================================================================================================

#ifndef WTC_CGVISITOR_H
#define WTC_CGVISITOR_H

#include <string>
#include "cginstrument.h"

namespace wtast
{
class AstNode;
} // wtast

namespace wtc
{
namespace codegen
{

class CodeGen;
class DataSection;
class ExternalsSection;

enum VisitMode
{
	VISIT_NORMAL,
	VISIT_GLOBALCTOR,
	VISIT_GLOBALDTOR,
};

void GenerateCode(CodeGen & cg, InstrumentEngine & eng, DataSection* datasec, ExternalsSection* extsec, wtast::AstNode* astnode, VisitMode visitmode=VISIT_NORMAL);

} // codegen
} // wtc

#endif // WTC_CGVISITOR_H
