/* $Id: ast_metadata.h 6310 2023-01-16 20:39:48Z aron $ */
/*
    Welltype parser and AST
    Copyright (C) 2014-2023  Aron Barath

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef WTPARSER_AST_METADATA_H
#define WTPARSER_AST_METADATA_H

#include <string>
#include "ast_entity.h"

namespace wtast
{

class Metadata : public Entity
{
	std::string mKey;
	std::string mValue;

public:
	Metadata(const std::string & key, const std::string & value)
		: Entity()
		, mKey(key)
		, mValue(value)
	{
		// ok
	}

	~Metadata()
	{
		// ok
	}

	Kind GetKind() const
	{
		return METADATA;
	}

	void Accept(AstVisitor* vis);

	Metadata* Copy();

	const std::string & GetKey() const
	{
		return mKey;
	}

	const std::string & GetValue() const
	{
		return mValue;
	}
};

} // namespace wtast

#endif // WTPARSER_AST_METADATA_H

